

--Attach --SHIFT+CTRL+A
macroScript SmartAttach
category:"SmartScripts"
tooltip:"SmartAttach"
(
	local objArray = #()
	local attachObj
	
	on execute do 
	(
		if (selection.count > 0) then
		(
			if getCommandPanelTaskMode() != #modify then max modify mode --always goes on top
			local currObj = Filters.GetModOrObj() --get base obj if no mod
			local modKey = FiltersEx.GetModifierKey() --gets the currently pressed modifier key
			
			if (selection.count == 1) then
			(
				--commented is a Placeholder functionality for future more advanced tool(also missing code for setting the corret cursor)
				-- attachObj = pickobject prompt:"Pick Object to attach"
				-- if not (isValidNode attachObj) then
				-- (messageBox "Please pick a valid object!")
				
				UtilitiesEx.SmartTurbosmoothOff currObj Remove:false --turn off turbosmooth
				ShorthandsEx.AttachMode currObj --universal standard attachmode
			)
			else 
			(
				--selection has more than 1 objects
				UtilitiesEx.attachAll (selection as array)
				--nurbsCurves may not work atm
			)
		) else
		( print "no selection")
	)
)

--Detach --SHIFT+CTRL+D (Round1: code typo fixed)
macroScript SmartDetach
category:"SmartScripts"
tooltip:"SmartDetach"
(
	--Note: need to test and fix wirecolor/material
	
	local objArray = #()
	on execute do 
	(
		if (selection.count > 0) then
		(
			if getCommandPanelTaskMode() != #modify then max modify mode --always goes on top
			local currObj = Filters.GetModOrObj() --get base obj if no mod
			local modKey = FiltersEx.GetModifierKey() --gets the currently pressed modifier key
			
			if ((subobjectLevel == 0) or (selection.count > 1)) then
			(
				--if not in subobjectlevel or more than 1 object selected
				--clone dialog
				actionMan.executeAction 0 "40213"
			) else
			(
				--Store current Object count as an array for comparing later
				objArray = objects as array
				
				Case of
				(
					(FiltersEx.Is_EPoly currObj):	
					(
						case  of
						(
							(subobjectLevel == 1):(currObj.buttonOp #BreakVertex)
							(subobjectLevel == 2 or subobjectLevel == 3):
							(
								case modkey of
								(
									default:
									(
										if(FiltersEx.Is_EditPolyObj currObj) then
										(currObj.ButtonOp #CreateShape)
										else
										(currObj.PopupDialog #CreateShape )
									)
									-- #shift_ctrl:
									-- (--Create Hard shape(not implimented)
									-- )
									-- #shift_ctrl_alt:
									-- (--Create smooth shape(not implimented)
									-- )
								)
							)
							(subobjectLevel == 4 or subobjectLevel == 5):
							(
								if (FiltersEx.Is_EditPolyObj currObj) then 
								(currObj.buttonOp #Detach) 
								else
								(currObj.PopupDialog #DetachFace)
							)
						)
						--must go out of subobject selection and go out of editpoly
						if (UtilitiesEx.Is_ObjCountDiffFrom objArray) then
						(
							subobjectLevel = 0
							UtilitiesEx.selectLastCreatedObj()
						)
					)
					(FiltersEx.Is_Spline currObj): 	
					(
						if (subObjectLevel==1)
						then (splineOps.startBreak currObj)
						else 
						(
							splineOps.detach currObj
							UIAccessor.PressDefaultButton()
						)
						
						if (UtilitiesEx.Is_ObjCountDiffFrom objArray) then
						(
							subobjectLevel = 0
							UtilitiesEx.selectLastCreatedObj()
						)
					)
					(FiltersEx.Is_EMesh currObj):
					(
						if (subObjectLevel==1)
						then (ApplyOperation Edit_Mesh meshops.break)
						else (ApplyOperation Edit_Mesh meshops.Detach)
						
						if (UtilitiesEx.Is_ObjCountDiffFrom objArray) then
						(
							subobjectLevel = 0
							UtilitiesEx.selectLastCreatedObj()
						)
					)
					(FiltersEx.Is_Unwrap_UVW currObj):
					(
						currObj.breakSelected()
					)
				)
			)
		) else
		( print "no selection")
	)
)


--Hide Selected --ALT+H (OK)
MacroScript SmartHide
Category:"SmartScripts"
Tooltip:"SmartHide"
(
	on execute do
	(
		local currObj = Filters.GetModOrObj() --get base obj if no mod
		
		if not(FiltersEx.Is_InSubObjectMode()) then 
		(
			if(selection.count > 0) then(max hide selection) 
			else (max hide inv)
			max select
		)
		else
		(
			if getCommandPanelTaskMode() != #modify then max modify mode
			local modKey = FiltersEx.GetModifierKey() --gets the currently pressed modifier key	
			case of
			(
				(FiltersEx.Is_EPoly currObj):
					(
						if(FiltersEx.Is_AnythingSelected currObj) then
						(
							if (FiltersEx.Is_EditPolyMod currObj) then
							(
								if (subobjectlevel == 1) then (currObj.ButtonOp #HideVertex)
								else (currObj.ButtonOp #HideFace)
							) else (currObj.buttonOp #HideSelection)
						) else
						(
							if (FiltersEx.Is_EditPolyMod currObj) then
							(
								if (subobjectlevel == 1) then currObj.ButtonOp #HideUnselectedVertex
								else currObj.ButtonOp #HideUnselectedFace
							) else currObj.buttonOp #HideUnselected
						)
					)
				(FiltersEx.Is_Spline currObj):
					(
						if(FiltersEx.Is_SplineShape currObj) then --if is scriptable spline then select al if nothing is selected and hide it
						(if not(FiltersEx.Is_AnythingSelected currObj) then (max select all))
						
						Try(ApplyOperation Edit_Spline Splineops.Hide)Catch()
					)
				(FiltersEx.Is_ObjectSet currObj):
					(hide currObj)
				(FiltersEx.Is_Unwrap_UVW currObj):
					(
						if not(FiltersEx.Is_AnythingSelected currObj) then
						(actionMan.executeAction 0 "40021"  /*Selection: Select All*/)
						actionMan.executeAction 2077580866 "40021" /*All Commands: Hide Selected*/
					)
				(FiltersEx.Is_EMesh currObj):
					(Try(ApplyOperation Edit_Mesh meshops.Hide)Catch())
			)
			max select
		)		
	)
)

--Unhide All SHIFT+CTRL+H (OK)
MacroScript SmartUnHideAll
Category:"SmartScripts"
Tooltip:"SmartUnHideAll"
(
	on execute do
	(
		local currObj = Filters.GetModOrObj() --get base obj if no mod
		
		if not (FiltersEx.Is_InSubObjectMode()) then 
		(
			max unhide all
		)
		else
		(
			if getCommandPanelTaskMode() != #modify then max modify mode
		
			local modKey = FiltersEx.GetModifierKey() --gets the currently pressed modifier key	
			case of
			(
				(FiltersEx.Is_EPoly currObj):
				(
					if (FiltersEx.Is_EditPolyMod currObj) then
					(
						for subobjectLevel = 1 to 4 do
						(
							if (subobjectlevel == 1) then (currObj.ButtonOp #UnhideAllVertex)
							else (currObj.ButtonOp #UnhideAllFace)
						)
					) else (currObj.buttonOp #UnhideAll)
				)
				(FiltersEx.Is_Spline currObj):
					(for subobjectLevel = 1 to 4 do Try(ApplyOperation Edit_Spline Splineops.UnHideAll)Catch())
				(FiltersEx.Is_ObjectSet currObj):
					(hide currObj)
				(FiltersEx.Is_Unwrap_UVW currObj):
					(currObj.filterselected())
				(FiltersEx.Is_EMesh currObj):
					(for subobjectLevel = 1 to 4 do Try(ApplyOperation Edit_Mesh meshops.UnHideAll)Catch())
			)
			max select
		)
	)
)