
Struct FiltersEx
(

--from filters
Function Is_EPoly modOrObj = (findItem #(Edit_Poly, Editable_Poly) (classof modOrObj) != 0),
Function Is_EditPolyMod modOrObj = (findItem #(Edit_Poly) (classof modOrObj) != 0),
Function Is_EditPolyObj modOrObj = (findItem #(Editable_Poly) (classof modOrObj) != 0),
Function Is_AnySubdiv modOrObj = (findItem #(TurboSmooth, MeshSmooth, OpenSubDiv) (classof modOrObj) != 0),
Function Is_EMesh modOrObj = (findItem #(Edit_Mesh, Editable_Mesh) (classof modOrObj) != 0),

Function Is_SplineShape modOrObj = (findItem #(Line, SplineShape) (classof modOrObj) != 0), --scriptable splines
Function Is_Spline modOrObj = (findItem #(Edit_Spline, Line, SplineShape) (classof modOrObj) != 0), --any editable splines
Function Is_NURBSCurve modOrObj = (findItem #(NURBSCurveshape, Point_Curve, CV_Curve) (classof modOrObj) != 0), --any nurbscurve

Function Is_NURBS modOrObj = (findItem #(Point_Surf, NURBSSurf) (classof modOrObj) != 0),
Function Is_Patch modOrObj = (findItem #(Edit_Patch, Quadpatch, Tripatch) (classof modOrObj) != 0),

Function Is_Unwrap_UVW modOrObj = (findItem #(Unwrap_UVW) (classof modOrObj) != 0),
Function Is_FFD modOrObj = (findItem #(FFDBox, FFDCyl, FFD_2x2x2, FFD_3x3x3, FFD_4x4x4) (classof modOrObj) != 0),
Function Is_ObjectSet modOrObj = (findItem #(ObjectSet) (classof modOrObj) != 0),
--FFD_Select

--just an idea, may need this for something
function Is_InSubObjectMode =
(
	local subObjmode = true
	
	if (getCommandPanelTaskMode() == #modify) then
	(
		if (subObjectLevel == 0) do (subObjmode = false)
	)
	else
	(
		subObjmode = false
	)
	return subObjmode
),

--experimental unified function
Function Is_AnythingSelected modOrObj =
	(
		--print "running experimental function Is_AnythingSelected"
		local hasActiveSelection = false
		case of
		(
			(FiltersEx.Is_EPoly modOrObj): 
				(
					if not(modOrObj.GetSelection #CurrentLevel).isEmpty do 
					(hasActiveSelection = true)
					/* print "printing selection collection: "
					print (modOrObj.GetSelection #CurrentLevel)
					print "hasActiveSelection ="
					print hasActiveSelection */
				)
			(FiltersEx.Is_SplineShape modOrObj): 
				(
					modOrObj = GetBaseNodeFrom modOrObj -- hack for issue with line not having the numsplines function
					if (subObjectLevel == 3) then (if (splineArray = getSplineSelection modOrObj).count > 0 then (hasActiveSelection = true)) 
					else
					(
						splineArray = for i=1 to (numSplines modOrObj) collect i
						if(subObjectLevel == 1) then
						(
							for spline in splineArray while not(hasActiveSelection) do
							(if (knotArray = getknotSelection modOrObj spline).count > 0 then (hasActiveSelection = true))
						)
						else if (subObjectLevel == 2) then
						(
							for spline in splineArray while not(hasActiveSelection) do
							(if (segArray = getSegSelection modOrObj spline).count > 0 then (hasActiveSelection = true))					
						)
					)
				)
			(FiltersEx.Is_Unwrap_UVW modOrObj):
				(
					sol = modOrObj.getTVSubObjectMode()
					selArray = #()
					case sol of
					(
						1:(selArray = modOrObj.getSelectedGeomVerts())
						2:(selArray = modOrObj.getSelectedGeomEdges())
						3:(selArray = modOrObj.getSelectedGeomVerts())					
					)
					if selArray.count > 0 then (hasActiveSelection = true)
				)
		)
		return hasActiveSelection
	),
--Function Is_Gizmo = ()

Function GetSubObjSelection modOrObj = --only editpoly right now
	(
		case of
		(
			(FiltersEx.Is_EPoly modOrObj): ( return (modOrObj.GetSelection #CurrentLevel))
			(FiltersEx.Is_SplineShape modOrObj): 
			(
				--getSegSelection modOrObj <spline_index_integer>
			)
		)
	),

------------------------GetObjTypeFrom------------------------------
Function GetObjTypeFrom modOrObj = (
	case of
	(
		(findItem #(Edit_Poly, Editable_Poly) (classof modOrObj) != 0):
				return #Edit_PolyModOrObj
--damn, will skip these 2, new solluton
		(findItem #(Edit_Poly) (classof modOrObj) != 0):
				return #Edit_Poly
					
		(findItem #(Editable_Poly) (classof modOrObj) != 0):
				return #Editable_Poly
					
		(findItem #(Edit_Mesh, Editable_Mesh) (classof modOrObj) != 0):
				return #Mesh
		
		(findItem #(Edit_Spline, Line, SplineShape) (classof modOrObj) != 0):
				return #Spline
					
		(Filters.Is_NURBS):
				return #NURBS
				
		(findItem #(Unwrap_UVW) (classof modOrObj) != 0):
				return #Unwrap_UVW
				
		default: return #none
	)
),

------------------------ GetModKey-------------------------
Function GetModifierKey = (
	case of
	(
		(keyboard.shiftPressed and not keyboard.controlPressed and not keyboard.altPressed):
				return #shift
					
		(keyboard.controlPressed and not keyboard.shiftPressed and not keyboard.altPressed):
				return #ctrl
					
		(keyboard.altPressed and not keyboard.controlPressed and not keyboard.shiftPressed):
				return #alt
					
		(keyboard.shiftPressed and keyboard.altPressed and not keyboard.controlPressed):
				return #shift_alt
					
		(keyboard.shiftPressed and keyboard.controlPressed and not keyboard.altPressed):
				return #shift_ctrl
					
		(keyboard.altPressed and keyboard.controlPressed and not keyboard.shiftPressed):
				return #alt_ctrl
					
		(keyboard.shiftPressed and keyboard.altPressed and keyboard.controlPressed):
				return #shift_ctrl_alt
		
		default: return #none
	)
	
)

)

--for combined functionality for dirrerent editpoly/editablepoly++ methods
struct ShorthandsEx
(
	Function Chamfer modOrObj Dialog:false =
	(
		print "universal chamfer function"
		local baseOp
		if Dialog then (baseOp = modOrObj.PopupDialog)
		else (baseOp = modOrObj.ButtonOp)
		--modOrObj.toggleCommandMode
		
		if (FiltersEx.Is_EditPolyMod modOrObj) then
		(
			case of
			(
				(subObjectLevel == 1):
				(baseOp #ChamferVertex)
				(subObjectLevel == 4):()
				(subObjectLevel == 0):()
				default:(baseOp #ChamferEdge)
			)		
		)
		else
		(
			if subObjectLevel > 0 do baseOp #Chamfer --for Editable_Poly
		)
		--restore hotkey functionality
		enableaccelerators = on
	),
	
	Function Bevel modOrObj Dialog:false =
	(
		print "universal bevel function"
		local baseOp
		if Dialog then (baseOp = modOrObj.PopupDialog)
		else (baseOp = modOrObj.ButtonOp)
		
		case of
		(
			(subObjectLevel == 4):(baseOp #Bevel)
			(subObjectLevel == 1):(baseOp #ExtrudeVertex)
			(subObjectLevel == 0):()
			default:(baseOp #ExtrudeEdge)
		)
		--restore hotkey functionality
		enableaccelerators = on
	),
	
	Function Inset modOrObj Dialog:false =
	(
		print "universal Inset function"
		local baseOp
		if Dialog then (baseOp = modOrObj.PopupDialog)
		else (baseOp = modOrObj.ButtonOp)
		
		case of
		(
			(subObjectLevel == 4):(baseOp #Inset)
			(subObjectLevel == 1):(baseOp #ChamferVertex)
			(subObjectLevel == 0):()
			default:(baseOp #ChamferEdge)
		)
		--restore hotkey functionality
		enableaccelerators = on
	),
	
	Function Extrude modOrObj Dialog:false =
	(
		print "universal Extrude function"
		local baseOp
		if Dialog then (baseOp = modOrObj.PopupDialog)
		else (baseOp = modOrObj.ButtonOp)
		
		case of
		(
			(subObjectLevel == 4):(baseOp #ExtrudeFace)
			(subObjectLevel == 1):(baseOp #ExtrudeVertex)
			(subObjectLevel == 0):()
			default:(baseOp #ExtrudeEdge)
		)
		--restore hotkey functionality
		enableaccelerators = on
	),

	Function Weld modOrObj operation Dialog:false =
	(
		local baseOp
		if Dialog then (baseOp = modOrObj.PopupDialog)
		else (baseOp = modOrObj.ButtonOp)
		
		case operation of
		(
			#weld:
			(
				--if(modOrObj.GetCommandMode() == #Weld) do (modOrObj.toggleCommandMode #Weld) --turn off tarbetweld mode (maybe change to setcommantmode) --not sure this is neccesary
				if FiltersEx.Is_EditPolyMod modOrObj then 
				(
					if (modOrObj.weldVertexThreshold == 0.1) do (modOrObj.weldVertexThreshold = 0.001)
					baseOp #WeldVertex
				)
				else 
				(
					if (modOrObj.weldThreshold == 0.1) do (modOrObj.weldThreshold = 0.001)
					baseOp #WeldSelected
				)
			)
			#targetweld:
			(
				modOrObj.toggleCommandMode #Weld
			)
			#weldAll:() --placeholder
			#weldBorder:() --placeholder
		)
	),
	
	Function SmartSlicePlane modOrObj operation =
	(
		case operation of
		(
			#Toggleplane:(modOrObj.ToggleCommandMode #SlicePlane)
			#PlaneSlice:
			(
				if (FiltersEx.Is_EditPolyMod modOrObj) then modOrObj.CommitAndRepeat() else
				(modOrObj.ButtonOp #Slice)--need to add the editablepoly spesific method this?(--modOrObj.ButtonOp #Slice)
			)
			#ToggleSlice:(modOrObj.ToggleCommandMode #Quickslice)
			#ResetPlane:(modOrObj.ButtonOp #Resetsliceplane)
		)
	),
	
	Function Cut modOrObj = --shorthand for editpoly/editablepoly
	(
		if (subObjectLevel == 0) then subObjectLevel = 1 --default to vertex if in obj mode
		
		if (FiltersEx.Is_EditPolyMod modOrObj) then
			(modOrObj.ToggleCommandMode #Cut)
		else --editablepoly
		(
			case of
			(
				(subObjectLevel == 1):(modOrObj.toggleCommandMode #CutVertex)
				(subObjectLevel == 2 or subObjectLevel == 3):(modOrObj.toggleCommandMode #CutEdge)
				(subObjectLevel == 4 or subObjectLevel == 5):(modOrObj.toggleCommandMode #CutFace)
			)
			
		)
	),

	--original author Lande3D (change to allow for dialog option?)
	Function AttachMode modOrObj =
	(
		case of
		(
			(FiltersEx.Is_EPoly modOrObj): (modOrObj.enterPickMode #Attach)
			(FiltersEx.Is_Spline modOrObj): (ApplyOperation Edit_Spline Splineops.startAttach)
			(FiltersEx.Is_NURBSCurve modOrObj): (UtilitiesEx.PressModPanelButtonByName "Attach")
			(FiltersEx.Is_Patch): (Try(ApplyOperation Edit_Patch PatchOps.Attach)Catch())
			(FiltersEx.Is_EMesh modOrObj):(ApplyOperation Edit_Mesh meshops.startAttach)
			(FiltersEx.Is_Unwrap_UVW):(modOrObj.stitchVertsDialog())
		)
	),
	
	--not optimal, normals are not unified
	Function SmartFlipNormals modOrObj =
	(
		local clearSelection = false
		case of
		(
			(FiltersEx.Is_EPoly modOrObj): 
			(
				if(subObjectLevel >= 4) do
				(
					if not (FiltersEx.Is_AnythingSelected modOrObj) do 
					(
						clearSelection = true
						max select all
					)
					if(FiltersEx.Is_EditPolyMod modOrObj) then
					(
						if (subobjectlevel == 4) then (modOrObj.buttonOp #FlipFace) else
						(modOrObj.buttonOp #FlipElement)
					) else (modOrObj.buttonOp #FlipNormals)
					if (clearSelection) do
					(max select none)
				)
			)
		)
	),
	
	--this does not work for seletion[1]
	Function MakeSmooth modOrObj =
	(
		preVal = modOrObj.autoSmoothThreshold --store current smooth treshold
		modOrObj.autoSmoothThreshold = 90 --apply temp autosmooth degree of 90(90 may be a bit high)
		
		modOrObj.ButtonOp #Autosmooth --apply the smoothing to selection (this appears to handle adj smoothing groups well enough)
		
		modOrObj.autoSmoothThreshold = preVal --set the smooth treshold back to default
	),
	
	--this does not work for seletion[1]
	Function ClearSmooth modOrObj =
	(
	--not sure if this is the best way to do it, needs testing
		--modOrObj.SetOperation #SetSmooth
		if (FiltersEx.Is_EditPolyMod modOrObj) then
		(
			modOrObj.setOperation #SetSmooth
			modOrObj.smoothingGroupsToSet = 0; modOrObj.smoothingGroupsToClear = -1	
		) else 
		(
			--may need to force an update after doing this(or maybe use polyop instead)
			modOrObj.buttonOp #ClearSmoothingGroups
		)

	),
	
	--old version, has bugs, finish v2 at a later time
	Function SmartSmoothSelection modOrObj =
	(
		--(modOrObj.GetSelection #CurrentLevel) -- this is similar to
		--selection[1].mesh.selectedfaces[1] -- this
		
		--need to handle no selection in subobject mode(one macro uses meshops for this, test this out)
		--if no sol selection then toggle clear smoothing / autosmooth all to 45d
		--this works for now but an automatic hard edge version would also be nice as well as a semihard normals interpolation toggle(single smoothing group)
		--also perhaps try to make a "worldspace version" that targets the top enabled editpoly and toggles hard/soft(60degrees) 
		--or just makes all objects clear smoothing if selection is more than 1
		
		--note 2: if all selected faces have the same smooth group then clear smooothing?
		print "smoothing"
		
		if (subobjectlevel < 4)then(subobjectlevel = 4) --default to face if less
		
		if (FiltersEx.Is_AnythingSelected modOrObj) then 
		(ShorthandsEx.MakeSmooth modOrObj) --if any faces are selected then always do smoothing operation
		else
		(
			--flip the state of all smoothing groups based on the first face in selection after max select all(will this always be the same??)
			--note:
			--1: get first face smoothing(need to select for editpoly to work? then need to do some trickery to try to reduce flicker)
			--2: if it has smoothing group of 0(?) then
			-- apply a smoothing operation of 45(?) degree to all faces
			--else clear smoothing
			
			--notes:
			--<Edit_Poly>.smoothingGroupsToSet Integer default: 0 -- integer;  Smoothing_Groups_to_Set(manual method)
			
			max select all --select all the faces
			
			if (getFaceSmoothGroup selection[1].mesh selection[1].mesh.selectedfaces[1].index) != 0 then --determine the smoothing state of the first face in selection(0 means no smoothing)
			(ShorthandsEx.ClearSmooth modOrObj)
			else
			(ShorthandsEx.MakeSmooth modOrObj)
		)
	),
	
	--not finished but seems to be working, can be simplified
	Function SmartSmoothV2Dev =
	(
		Global SmoothTreshold = 60
		function MakeSmooth modOrObj treshold:60 =
		(
			preVal = modOrObj.autoSmoothThreshold --store current smooth treshold
			modOrObj.autoSmoothThreshold = treshold --apply temp autosmooth degree of 90(90 may be a bit high)
			
			modOrObj.ButtonOp #Autosmooth --apply the smoothing to selection (this appears to handle adj smoothing groups well enough)
			
			modOrObj.autoSmoothThreshold = preVal --set the smooth treshold back to default
		)

		function ClearSmooth modOrObj =
		(
		--not sure if this is the best way to do it, needs testing
			--modOrObj.SetOperation #SetSmooth
			if (FiltersEx.Is_EditPolyMod modOrObj) then
			(
				modOrObj.setOperation #SetSmooth
				modOrObj.smoothingGroupsToSet = 0; modOrObj.smoothingGroupsToClear = -1	
			) else 
			(
				--may need to force an update after doing this(or maybe use polyop instead)
				modOrObj.buttonOp #ClearSmoothingGroups
			)

		)
		
		--notes: both functions are not handling situations where turbosmooth etc is enabled and on top of the epoly in the stack. 
		--i think the main reason is that im not able to collect the current smoothing group via the basenode trick if it is turbosmoothed.
		--also the editpoly function is not handling if it is not selected in the stack, may need to write a recurse stack function for that
		--tested ok for any epoly/editablepoly but it needs to be selected and turbosmooth(and others?) on top in the stack messes it up
		
		--notes2: i could also fix the turbosmooth issue by making a change to my smartturbosmoothoff function to restore selection.
		Function ToggleSmoothGroup = 
		(
			print "single object selected and in subobject mode"
			if getCommandPanelTaskMode() != #modify then (max modify mode) --switch to modpanel
			
			modOrObj = Filters.GetModOrObj()
			if(FiltersEx.Is_Epoly modOrObj) then
			(
				--UtilitiesEx.SmartTurbosmoothOff selection[1] selecting the ts = not good
				toggleAllFaces = false
				prevSubObjectLevel = undefined
				prevFaceSelection = #{}
				if (subObjectLevel >= 4 and subObjectLevel != 0) then
				(
					print "sol is higher than 4 but not 0"
					if (modOrObj.GetSelection #CurrentLevel).isEmpty then
					(
						toggleAllFaces = true -- for flipping the state
						max select all --select all the faces
						print "no selection so toggle smoothing for all faces"
					)
				) else
				(
					prevSubObjectLevel = subObjectLevel --get current SOL
					prevFaceSelection = modOrObj.GetSelection #Face --get face selection if there are any
					toggleAllFaces = true
					solSelection = modOrObj.GetSelection #CurrentLevel
					if solSelection == undefined then solSelection = #{} --create a ampty collection for solSelection
					if not(solSelection).isEmpty then
					(
						modOrObj.ConvertSelection #CurrentLevel #Face; subObjectLevel = 4 --convert selction to face SOL+switch to face
					) else
					(
						subObjectLevel = 4; max select all --switch to face SOL and select all the faces and switch to face
					)
				)		
				if not (modOrObj.GetSelection #CurrentLevel).isEmpty then --use this to quickly find out if anything is selected(do this again to protect against empty mesh objects)
				(
					baseNode = UtilitiesEx.Get_PolyMeshIFaceFor modOrObj --for hacky unified editpoly editablepoly functionality
					if classof (baseNode) == trimesh then --check if it is valid
					(
						print "BaseNode target:"; print baseNode
						
						print "BaseNode class"; print (classof baseNode)
						
						selFaces = baseNode.selectedfaces
						print(baseNode.selectedfaces)
						selFaceIndex1 = baseNode.selectedfaces[1].index
						
						--selFaces = baseNode.mesh.selectedfaces
						--selFaceIndex1 = baseNode.mesh.selectedfaces[1].index
						
						print "Smoothgroup for selection index:"; print selFaceIndex1
						
						smoothgroup = (getFaceSmoothGroup baseNode selFaceIndex1)
						
						--smoothgroup = (getFaceSmoothGroup baseNode.mesh selFaceIndex1)
						
						print "Is:"; print (smoothgroup)
						--if smoothGroup == 0 then (MakeSmooth modOrObj Treshold:46) else (ClearSmooth modOrObj) --old interactive code
						if smoothGroup != 0 then
						(print "clearing smoothinggroups";ClearSmooth modOrObj) 
						else (print "autosmoothing";MakeSmooth modOrObj Treshold:SmoothTreshold)
						
						if (toggleAllFaces or prevFaceSelection.isEmpty) do (max select none)
						if not(prevFaceSelection.isEmpty) do 
						(
							--recover previously selected faces
						)
						if prevSubObjectLevel != undefined do (subObjectLevel = prevSubObjectLevel) --finally reset sol selection level
					) else (print "basenode is undefined")
				) else (print "no faces in the object")
			) else (print "selected is not epoly")
		)
		
		--this works well for multiple editablepoly objects, filters out non editablepoly(no errors so far) does not do work on objects with deforming modifiers on top
		Function ToggleSmoothGroupMulti =
		(
			print "more than 1 object selected or not in sol+editablepoly"
			for obj in selection do UtilitiesEx.SmartTurbosmoothOff obj
			makeObjectsSmooth = false
			--collecting the valid objects
			polyOpObjects = (for obj in selection where classof obj == Editable_Poly collect obj)
			polyMeshObjects = (for obj in selection where classof obj == PolyMeshObject collect obj) 
			--getting the smoothing group of the first face in the first object
			if polyOpObjects.count > 0 then 
			(makeObjectsSmooth = (polyop.getFaceSmoothGroup polyOpObjects[1] 1) == 0)
			else if polyMeshObjects.count > 0 do
			(
				print "found some polymeshes"
				print "the first of which has a first face smoothing group of:"
				print (GetFaceSmoothGroup polymeshObjects[1].mesh 1)
				
				makeObjectsSmooth = (GetFaceSmoothGroup polymeshObjects[1].mesh 1) == 0
				print "makesmoothset to:"
				print makeObjectsSmooth
			)
			for obj in polyOpObjects do
			(
				if makeObjectsSmooth then
				(
					preVal = obj.autoSmoothThreshold
					obj.autoSmoothThreshold = SmoothTreshold
					--t1 = timestamp()
					polyop.setfaceselection obj #all
					polyop.autosmooth obj
					obj.autoSmoothThreshold = preVal
					--format "count: %(%) time: %\n" faces.numberset obj.numverts (timestamp() - t1)
					polyop.setFaceSelection obj #none --clear face selection
				) else
				(polyop.SetFaceSmoothGroup obj #all 0) --this works for clearing smoothinggroups for editablepoly
				update obj --update the object in viewport
			)
			for obj in polymeshObjects do
			(
	-- 					if makeObjectsSmooth then
	-- 					(
					--print "epoly object, smoothing not implimented"
	-- 					) else
	-- 					(
	-- 						for face in obj.mesh.faces do
	-- 						(
	-- 							--print face.index
	-- 							SetFaceSmoothGroup obj.mesh face.index 0
	-- 						)
	-- 						update obj.mesh
	-- 					)
			)
		)
		
		clearlistener()
		local epOverride = false
		if selection.count == 0 do (max select all) -- select all if there is no selection
		if selection.count == 1 then 
		(
			if (classof selection[1] == Editable_Poly) do --override check for the polyop interface
			(
				if (getCommandPanelTaskMode() == #modify) then
				(
					if (subObjectLevel == 0) do epOverride = true
				) else (epOverride = true)
			)
			if epOverride then
			(ToggleSmoothGroupMulti()) 
			else (ToggleSmoothGroup())
		) 
		else if (selection.count > 0) do (ToggleSmoothGroupMulti()) --one final check
	)

)

struct DefaultsEx
(
function setDefaultsFor modOrObj toolOrMod next:false =
(
		print "set defaults function"
		if next then
		(print "set to preset")
		else
		(print "set to default")
		
		--settingsarray
		case toolOrMod of
		(
			#ExtrudeEdge:
			(
				print "set tool to default"
				if(modOrObj.extrudeEdgeHeight = 10.0 and modOrObj.extrudeEdgeWidth = 3.0) do
				(modOrObj.extrudeEdgeHeight = 0.0 ; modOrObj.extrudeEdgeWidth = 0.0)
			)
			#ExtrudeVertex:
			(
				print "set tool to default"
				if(modOrObj.extrudeVertexHeight = 10.0 and modOrObj.extrudeVertexWidth = 3.0) do
				(modOrObj.extrudeVertexHeight = 0.0 ; modOrObj.extrudeVertexWidth = 0.0)
			)
			#Bevel:
			(
				if not next then 
				(
					print "set tool to default"
					--"Global" defaults
					if (FiltersEx.Is_EditPolyObj modOrObj) then
					(
						if(modOrObj.bevelHeight == 10.0 and modOrObj.bevelOutline == -1.0 and modOrObj.bevelType == 0) do
						(
							modOrObj.bevelHeight = 0.0
							modOrObj.bevelOutline = 0.0
							modOrObj.bevelType = 1
						) --fix the "awful" defaults of editablepoly
					)
					else
					(
						if (modOrObj.bevelType == 0 and modOrObj.bevelHeight == 0.0 and modOrObj.bevelOutline == 0.0) do
						(modOrObj.bevelType = 1) --override defaults in editpoly(change to normal instead of group)
					)
				) 
				else
				(
					print "cycle beveltypes"
					case modOrObj.bevelType of
					(
						0:(modOrObj.bevelType = 1)
						1:(modOrObj.bevelType = 2)
						2:(modOrObj.bevelType = 0)
					)
				)
			)
			#ChamferEdge:
			(
				if not next then --reset or set default
				(
					print "set tool to default"
					
					-- if (FiltersEx.Is_EditPolyObj modorObj) then
					-- ()
					-- else()
					
					if modOrObj.edgeChamferType != 0 do
					(modOrObj.edgeChamferType = 0)
					
					if(modOrObj.edgeChamferSmoothType != 1 and modOrObj.edgeChamferAmount != 0.0) do 
					(modOrObj.edgeChamferSmoothType = 1) --smooth chamfer only	
					--modOrObj.edgeChamferSmooth = off --alt(no smoothing)
				) else
				(
					print "set tool to preset"
					case of
					(
						(modOrObj.edgeChamferType == 0): --Preset 2(press 2)
						(
							modOrObj.edgeChamferType = 1
							modOrObj.edgeChamferTension = 0.5 --Soft
						)
						(modOrObj.edgeChamferType == 1 and modOrObj.edgeChamferTension == 0.5): --Preset 3(press 3)
						(
							modOrObj.edgeChamferTension = 0.0 --Hard
						)
						(modOrObj.edgeChamferType == 1 and modOrObj.edgeChamferTension == 0.0): --Preset 4(Press 4)
						(
							modOrObj.edgeChamferType = 0
						)
					)
				)
			)
			#ChamferVertex:
			(
				if not next then
				(
					print "set tool to default"
					if (FiltersEx.Is_EditPolyObj modorObj) then
					(
						if modOrObj.vertexChamfer == 1.0 do modOrObj.vertexChamfer = 0.0
					)
					else
					(
						--placeholder
						--if modOrObj.vertexChamfer == 0.0 do modOrObj.vertexChamfer = 0.0
					)
				)
				else
				(
				
				)
			)
			#Inset:
			(
				if not next then
				(
					if (FiltersEx.Is_EditPolyMod modOrObj) then
					(
						--placeholder
						--if modOrObj.insetAmount == 0.0 do modOrObj.insetAmount = 0.0
					)
					else
					(
						if modOrObj.insetAmount == 1.0 do modOrObj.insetAmount = 0.0
					)
				)
				else
				(
					print "Toggle insettype"
					if (modOrObj.insetType != 1) then (modOrObj.insetType = 1)--toggle
					else (modOrObj.insetType = 0)
				)

			)
			default:(print "DefaultsFunction passed inproper toolOrMod arguement")
		)
	)
)

struct UtilitiesEx
(

	function Get_PolyMeshIFaceFor modorObj =
	(
		print "get BaseNode array:"
		baseNodeArray = refs.dependents (modOrObj)
		print "classes in BaseNode array:"
		for node in baseNodeArray do (print (classof node))
		
		print "collect polymeshobjects:"
		polyMeshNodes = for node in baseNodeArray where
		classof node == PolyMeshObject or classof node == Editable_Poly collect node.mesh
		
		meshNodes = for node in baseNodeArray where classof node ==  Editable_mesh collect node.mesh
		
		--join polyMeshNodes meshNodes 
		print polyMeshNodes
		return polyMeshNodes[1]
	),
	
	--original author denisT & Plastic on CgTalk(gets selected faces from editpoly objects without going into modpanel)
	function GetPolyMeshObjectFaceSelection obj =
	 (
		with undo off with redraw off
		(
			tempEditablePoly=copy obj
			convertToPoly tempEditablePoly
			selectedFaces=polyOp.getFaceSelection tempEditablePoly
			delete tempEditablePoly
			selectedFaces
		)
	 ),
	
	--original author Lande3D
	--For functions that dont have macros or exposed functions
	Function PressModPanelButtonByName ButtonName =
	(
		if getCommandPanelTaskMode() != #modify then max modify mode --always goes on top
		
		try(
			maxHWND = windows.getMAXHWND()
			cmdHWND = for c in windows.getChildrenHWND #max where c[4] == "ModifyTask" do exit with c[1]
	 
			btnHWND = (windows.getChildHWND cmdHWND ButtonName)[1]
			(
				UIAccessor.PressButton btnHWND -- press the button
			)
		)catch()
	),
	
	--Original author Lande3D(rework finished)
	Function Is_NamedDialogActive DialogName =
	(
		isActive = false
		--print (UIAccessor.GetPopupDialogs())
		--method 1
		--for d in UIAccessor.GetPopupDialogs() where (UIAccessor.GetWindowText d) == "Chamfer Vertices" do print (UIAccessor.GetWindowText d)
		--for d in UIAccessor.GetPopupDialogs() where (UIAccessor.GetWindowText d) == "Particle View" do exit with d
		--method 2
		--if (hwnd = windows.getchildhwnd 0 "Chamfer Vertices") != undefined then print "found" else print "nope"
		
		-- try
		-- (
			-- child = (windows.getChildHWND 0 DialogName )
			-- if (child != undefined) then
			-- (
				-- return true
			-- ) else 
			-- (
				-- return false
			-- )
		-- )
  		-- catch()

		foundDialogs = for dialog in UIAccessor.GetPopupDialogs() where findString (UIAccessor.GetWindowText dialog) DialogName != undefined collect dialog
		print foundDialogs
		if foundDialogs.count > 0 do isActive = true
		return isActive
	),
	
	--Original author Lande3D(wrapper for Is_NamedDialogActive)
	Function Is_DialogActiveFor toolOrMod =
	(
		isActive = false
		
		case toolOrMod of
		(
			#Bevel:(isActive = UtilitiesEx.Is_NamedDialogActive "Bevel Polygons")
			#Chamfer: --universal chamfer
			(
				if(UtilitiesEx.Is_NamedDialogActive "Chamfer Edges") or
				(UtilitiesEx.Is_NamedDialogActive "Chamfer Vertices") do 
				(isActive = true)
			)
			#ChamferEdge:(isActive = UtilitiesEx.Is_NamedDialogActive "Chamfer Edges")
			#ChamferVertex:(isActive = UtilitiesEx.Is_NamedDialogActive "Chamfer Vertices")
			#Extrude: --universal extrude
			(
				if(UtilitiesEx.Is_NamedDialogActive "Extrude Polygons") or --guessing
				(UtilitiesEx.Is_NamedDialogActive "Extrude Edges") or
				(UtilitiesEx.Is_NamedDialogActive "Extrude Vertices") do
				(isActive = true)
			)
			#ExtrudeEdge: (isActive = UtilitiesEx.Is_NamedDialogActive "Extrude Edges")
			#ExtrudeVertex: (isActive = UtilitiesEx.Is_NamedDialogActive "Extrude Vertices")
			#ExtrudePoly: (isActive = UtilitiesEx.Is_NamedDialogActive "Extrude Polygons")
			#Inset:(isActive = UtilitiesEx.Is_NamedDialogActive "Inset Polygons")
		)
		
		return isActive
	),
	
	function selectLastCreatedObj = 
	(
		objID = amax (for obj in objects collect obj.inode.handle) 
		select (maxOps.getNodeByHandle objID)
	),

	--original author Lande3D(compares the count of an object array to the current objects in the scene)
	function Is_ObjCountDiffFrom ObjArray =
	(
		if ObjArray.count != (objects as array).count then
		(
			return true
		)
		else
		(
			return false
		)
	),
	

	--For MakePlanar etc(Placeholder)
	Function ScaleEx xAxis yAxis zAxis =
	(
		--Do this here for now
		modOrObj = modPanel.getCurrentObject()

		--this does the job first time, but changes the vert selection, and if the vert selection is otherwise changed the operation wont work
		selectionArray = modOrObj.GetSelection #Vertex
		if selectionArray.numberset != 0 do
		(
			centerPos = [0,0,0]
			for v in selectionArray do
			(
				vPos = modOrObj.getVertex v
				centerPos.x += vPos.x
				centerPos.y += vPos.y
				centerPos.z += vPos.z
			)
			centerPos /= selectionArray.numberset
 
			modOrObj.SetOperation #Transform
			modOrObj.ScaleSelection  [xAxis, yAxis, zAxis] parent:(transMatrix centerPos) axis:(transMatrix centerPos)
			modOrObj.Commit ()
		)
		
	),
	
	-- Original Author Miauu(for validating directories)
	function ValidateDirectory _dirNameIn =
	(
		local _dirName = copy _dirNameIn
		local c
		for i = _dirName.count to 1 by -1 while (c=_dirName[i]; c=="\\" or c== "/") do
			_dirName = subString _dirName 1 (i-1)
		
		if doesFileExist _dirName then
			dirExists = true
		else
			dirExists = false
		
		return dirExists
	),

	--Original Author Lande3D(aligns objects on spesific axis)
	function ObjPlanar pAxis =
	(
		if selection.count > 1 then
		(
			local zeroAlign = false
			local sharedAxisPoint = 0;
			local position = #()
			for obj in selection while not(zeroAlign) do --check if any of the objects have a units axis of between 0.1 and -0.1
			(
				if maxOps.pivotMode == #pivotOnly then --if pivot only
				(
					if (position = obj.pivot) == Undefined do (position = obj.pos) --in case object has no pivot?
				)else (position = obj.pos)
				
				case of
				(
					(pAxis == #X and (position[1] < 0.1 and position[1] > -0.1)):(zeroAlign = true)
					(pAxis == #Y and (position[2] < 0.1 and position[2] > -0.1)):(zeroAlign = true)
					(pAxis == #Z and (position[3] < 0.1 and position[3] > -0.1)):(zeroAlign = true)
				)
			)
			
			if not(zeroAlign) then --set align axis point
			(
				selCenter = selection.center
				case pAxis of
				(
					#X:(sharedAxisPoint = selCenter[1])
					#Y:(sharedAxisPoint = selCenter[2])
					#Z:(sharedAxisPoint = selCenter[3])
				)
			)
			if maxOps.pivotMode != #pivotOnly then --if not pivot only
			(
				for obj in selection do 
				(
					x = obj.pos[1]; y = obj.pos[2]; z = obj.pos[3]
					case pAxis of
					(
						#X:(obj.pos = [sharedAxisPoint,y,z])
						#Y:(obj.pos = [x,sharedAxisPoint,z])
						#Z:(obj.pos = [x,y,sharedAxisPoint])
					)
				)
			) else 
			(
				for obj in selection do 
				(
					x = obj.pivot[1]; y = obj.pivot[2]; z = obj.pivot[3]
					case pAxis of
					(
						#X:(obj.pivot = [sharedAxisPoint,y,z])
						#Y:(obj.pivot = [x,sharedAxisPoint,z])
						#Z:(obj.pivot = [x,y,sharedAxisPoint])
					)
				)
				maxOps.pivotMode = #none
			)
		)
		else --only one object selection align to world 0 axis
		(
			obj = $ --base object
			if maxOps.pivotMode != #pivotOnly then --if not pivot only
			(
				x = obj.pos[1]; y = obj.pos[2]; z = obj.pos[3]
				case of
				(
					(pAxis == #X and obj.pos[1] != 0):(obj.pos = [0,y,z])
					(pAxis == #Y and obj.pos[2] != 0):(obj.pos = [x,0,z])
					(pAxis == #Z and obj.pos[3] != 0):(obj.pos = [x,y,0])
				)
			) else
			(
				x = obj.pivot[1]; y = obj.pivot[2]; z = obj.pivot[3]
				case of
				(
					(pAxis == #X and obj.pivot[1] != 0):(obj.pivot = [0,y,z])
					(pAxis == #Y and obj.pivot[2] != 0):(obj.pivot = [x,0,z])
					(pAxis == #Z and obj.pivot[3] != 0):(obj.pivot = [x,y,0])
				)
				maxOps.pivotMode = #none
			)
		)
	),
	
	--original author Lande3D (wrapper for poly/shapeAttachMulti)(warning suspends updates to modpanel. will cause issues if the script crashes in the middle)
	Function attachAll objArray =
	(
		print "Run multiAttach(wrapper)"
		print "Array of objects:"
		print objArray
		--for o in geometry where classof o == Box do
		try
		(
			suspendEditing() --suspend the modpanel updates
			
			geoObj = for obj in objArray where (superclassof obj == GeometryClass) collect obj
			shapeObj = for obj in objArray where (superclassof obj == shape) collect obj
			
			if geoObj.count > 0 do (UtilitiesEx.PolyAttachMulti geoObj)
			if shapeObj.count > 0 do (UtilitiesEx.ShapeAttachMulti shapeObj)
			
			resumeEditing() --resume the modpanel updates
		)catch(resumeEditing()) --not sure if trycatch works here
	),
	
	--original author Lande3D (based on idea from cgforums) (obs: testing with redraw off)
	Function PolyAttachMulti objArray =
	 (
		local lastObj = objArray[objArray.count] --get a reference to the last selected item in the array
		UtilitiesEx.SmartTurbosmoothOff lastObj Remove:true NoUpdate:True
		converttopoly lastObj
		with redraw off
		(
			for i = 1 to (objArray.count - 1) do
			(
				UtilitiesEx.SmartTurbosmoothOff objArray[i] Remove:True NoUpdate:True
				converttopoly objArray[i]
				polyop.attach lastObj objArray[i]
			)	
		)

	 ),
	
	--original author Lande3D (obs: testing with redraw off)
	Function ShapeAttachMulti objArray =
	(
		local lastObj = objArray[objArray.count] --get a reference to the last selected item in the array
		--UtilitiesEx.SmartTurbosmoothOff lastObj Remove:true NoUpdate:True
		convertToSplineShape lastObj; updateShape lastObj
		with redraw off
		(
			for i = 1 to (objArray.count - 1) do
			(
				--UtilitiesEx.SmartTurbosmoothOff objArray[i] Remove:True NoUpdate:True
				convertToSplineShape objArray[i]; updateShape objArray[i]
				addAndWeld lastObj objArray[i] 0.0; updateShape lastObj
			)
		)
	),
	
	Function GetBaseNodeFrom modOrObj =
	(
		if IsValidNode (basenode = refs.dependents(modOrObj)[1]) then
		(return basenode ) else 
		(
			return modOrObj
		)
	),
	
	--original author Lande3D(pending slight rework in functionality)
	Function SmartTurbosmoothOff nodeOrObj Remove:false NoUpdate:false =
	(
		--<array>nodeLocalBoundingBox <node>  not related but nice
		--SmartTurbosmoothOff (filters.Getmodorobj()) only works in edit mode
		--SmartTurbosmoothOff selection[1] always works
		
		--viewport flicker reduction
		--with redraw off (for turning viewport redraw off while doing something):
		--suspendEditing(); resumeEditing()  --in order to force update of the modpanel

		if IsValidNode nodeOrObj do
		(
			local endLoop = false
			local modifiers = nodeOrObj.modifiers
			
			for i = 1 to modifiers.count where not endLoop do
			(
				
				if remove then
				(
					if FiltersEx.Is_AnySubdiv modifiers[1] then --if the current top node is subdiv then
					(deleteModifier nodeOrObj 1) -- remove it and continue(next mod becomes top node)
					else (endLoop = true) --if anything else then endloop
				) else
				(
					if FiltersEx.Is_AnySubdiv modifiers[i] then --if the current node is subdiv then
					(modifiers[i].enabled = false) --disable it and continue
					else (endLoop = true) --if anything else then endloop
				)
			)
			if not noUpdate do
			(
				if nodeOrObj == selection[1] and getCommandPanelTaskMode() == #modify  do --may not work on instanced obj
				(
					suspendEditing(); resumeEditing() 
					--in order to force an update of the modpanel(if doing longer attach chains then it may be better to do this before and after the attach op)
				)
			)
		)
	),
	
	--placeholder
	Function ConvertOrAddTurbosmoothInstance objArray =
	(
	),
	
	--Original Author Lande3D (Untested(traverse each obj stack and collect handles to top editpoly/editablepoly baseobjects) )
	Function ReturnEPolyHandles objArray =
	(
		local epolyArray = #()
		local endloop = false
		for obj in objArray do 
		(
			endLoop = false
			for modifier in obj.modifiers where not endloop do
			(
				if FiltersEx.Is_EPoly modifier do 
				(
					appendIfUnique epolyArray modifier
					endLoop = true
				)
			)
		)
	)
)

--mainly external tools converted in some way
struct ToolsEx
(
	function IC_GeoEdgeLoop =
	(
		try(macros.run "IC_EdgeLoop" "IC_GeoEdgeLoop")catch()
	)
)

--Stuff that is run on max startup(currently empty)
struct RunOnStartup
(
	function RunOnce =
	(

	)
)
RunOnStartup.RunOnce()